
const TAGS_PREF_DISABLE = "extensions.tagseverywhere.disable";
const TAGS_PREF_CLOUDS = "extensions.tagseverywhere.clouds";
const TAGS_PREF_NEWWINDOW = "extensions.tagseverywhere.newwindow";
const TAGS_PREF_CACHE = "extensions.tagseverywhere.cache";
const TAGS_PREF_SHOWPLAIN = "extensions.tagseverywhere.showplain";
const TAGS_PREF_SHOWSE = "extensions.tagseverywhere.showse";
const TAGS_PREF_SHOWWEB2 = "extensions.tagseverywhere.showweb2";
const TAGS_PREF_EXCLUDE = "extensions.tagseverywhere.exclude";


const TAGS_BEGIN = "<div class=\"alphacloud\">";
const TAGS_END = "</div>";


const TAGS_NOTIFY_STATE_DOCUMENT = Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT;
const TAGS_NOTIFY_STATE_ALL = Components.interfaces.nsIWebProgress.NOTIFY_STATE_ALL;
const TAGS_STATE_IS_DOCUMENT = Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT; 
const TAGS_STATE_START = Components.interfaces.nsIWebProgressListener.STATE_START; 
const TAGS_STATE_REDIRECTING = Components.interfaces.nsIWebProgressListener.STATE_REDIRECTING; 

var tagseverywhere_doc = false;
var tagseverywhere_reqs = new Array();
var tagseverywhere_md5 = false;

var tagseverywhere_cache = null;

function tagseverywhere_LoadURL(URL)
{
	
    window.content.document.location = URL;
    window.content.focus();
}

function tagseverywhere_getBoolPref(prefName, defval)
{ 
      var result = defval; 
      var prefservice = Components.classes["@mozilla.org/preferences-service;1"] 
            .getService(Components.interfaces.nsIPrefBranch); 
      try { result = prefservice.getBoolPref(prefName); } 
      catch(e){ prefservice.setBoolPref(prefName, defval); result = defval; } 
      return(result); 
}

function tagseverywhere_setBoolPref(prefName, val)
{ 
	var prefservice = Components.classes["@mozilla.org/preferences-service;1"] 
		.getService(Components.interfaces.nsIPrefBranch); 
	prefservice.setBoolPref(prefName, val);
}

function tagseverywhere_getStrPref(prefName)
{ 
      var result = "";
      var prefservice = Components.classes["@mozilla.org/preferences-service;1"] 
            .getService(Components.interfaces.nsIPrefBranch); 
      try { result = prefservice.getCharPref(prefName); } 
      catch(e){} 
      return result; 
}

function tagseverywhere_setStrPref(prefName, val)
{ 
	var prefservice = Components.classes["@mozilla.org/preferences-service;1"] 
		.getService(Components.interfaces.nsIPrefBranch); 
	prefservice.setCharPref(prefName, val);
}

function tagseverywhere_isSetPref(prefName)
{ 
	var prefservice = Components.classes["@mozilla.org/preferences-service;1"] 
		.getService(Components.interfaces.nsIPrefBranch); 
	try {
		return prefservice.prefHasUserValue(prefName);
	} catch(e) {} 
	return false; 
}

function tagseverywhere_getHost(sUrl)
{
	var i = sUrl.indexOf("://");
	if (i == -1)
		return "";
	var j = sUrl.indexOf("/", i + 3);
	var sHost;
	if (j == -1)
		sHost = sUrl.substring(i+3);
	else
		sHost = sUrl.substring(i+3, j);
	return sHost;
}


function tagseverywhere_ReplaceAll(str,s,s2)
{
	return str.split(s).join(s2);
}



function tagseverywhere_ParseTags(sText)
{
	if (! tagseverywhere_doc)
		return null;
	var i = sText.indexOf(TAGS_BEGIN);
	if (i == -1)
		return null;
	var i2 = sText.indexOf(TAGS_END, i + TAGS_BEGIN.length);
	if (i2 == -1)
		return null;
	var s = sText.substring(i + TAGS_BEGIN.length, i2);

	var sTarget = "";
	var bNewWindow = tagseverywhere_getBoolPref(TAGS_PREF_NEWWINDOW, true);
	if(bNewWindow)
		sTarget = " target=\"_blank\"";

	var bClouds = tagseverywhere_getBoolPref(TAGS_PREF_CLOUDS, true);

	var a = s.split("\n");
	var aTags = new Array();
	for (i=0; i<a.length; i++)
	{
		if (a[i].length > 0)
		{
			var b = a[i].match(/<a href="\/tag\/([^"]+)" class="s([^"]+)">([^<]+)<\/a>/);
			if (b != null)
				if (b.length > 3)
				{
					var aTag = new Array();
					aTag[0] = (8 + (2 * parseInt(b[2])));
					aTag[1] = b[1];
					aTag[2] = b[3];
					aTags[aTags.length] = aTag;
				}
		}
	}

	var bCache = tagseverywhere_getBoolPref(TAGS_PREF_CACHE, true);
	if (bCache)
	{
		tagseverywhere_cache[tagseverywhere_md5] = aTags;
	}

	return aTags;
}

function tagseverywhere_ShowTags(page, aTags)
{
	if (! tagseverywhere_doc)
		return false;

	var sTarget = "";
	var bNewWindow = tagseverywhere_getBoolPref(TAGS_PREF_NEWWINDOW, true);
	if(bNewWindow)
		sTarget = " target=\"_blank\"";

	var bClouds = tagseverywhere_getBoolPref(TAGS_PREF_CLOUDS, true);

	var i, b;
	var ss = "";

	if (aTags == null)
	{
		ss += "no tags";
	} else {
		if (aTags.length == 0)
			ss += "no tags";
		for (i=0; i<aTags.length; i++)
		{
			b = aTags[i];
			var font_size = bClouds ? b[0] : 12;
			ss += "<a href=\"http://del.icio.us/tag/" + b[1] + "\" style=\"text-decoration: none; background: #F0F0F0; color: #000000;\" " + sTarget + "><span style=\"text-decoration: none; background: #F0F0F0; color: #000000; font: " + font_size + "px arial;\">" + b[2] + "</span></a>\n";
		}
	}
	page.innerHTML='&nbsp; <b>Common tags</b>: ' + ss;
	return true;
}






function tagseverywhere_GetTags(sUrl, page)
{
	var req = new XMLHttpRequest();
	var i = tagseverywhere_reqs.length;
	tagseverywhere_reqs[i] = req;

	req.onreadystatechange = function()
	{ 
		if(req.readyState == 4)
		{
			if(req.status == 200) 
			{
				var aTags = tagseverywhere_ParseTags(req.responseText);
				tagseverywhere_ShowTags(page, aTags);
			} else {
				tagseverywhere_ShowTags(page, null);
			}
			req.onreadystatechange = function() {};
			tagseverywhere_reqs[i] = null;
		}
	}; 
	var sHost = tagseverywhere_getHost(sUrl);
	tagseverywhere_md5 = hex_md5(sUrl);
	var s = "http://del.icio.us/url/" + tagseverywhere_md5;
//alert(s);
	req.open("GET", s, true);
	req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	req.send(null);
}




function tagseverywhere_ShowPageTags(sUrl, aTags)
{
	if (! tagseverywhere_doc)
		return false;

	var page = tagseverywhere_doc.createElement('DIV');
	page.setAttribute('id','tagseverywhere-bar');
	page.setAttribute('align','center');
	page.setAttribute('style','font: 12 arial; color: #000000; background:#F0F0F0;width:100%;padding:0pt;margin:0pt;z-index:1000;position:relative');
	page.innerHTML='&nbsp; <b>Common tags</b>: wait...';
	try
	{
		tagseverywhere_doc.body.insertBefore(page, tagseverywhere_doc.body.firstChild);
	} catch(e) {
		//alert('Debug. Insert top panel: '+e);
		return false;
	}

	if (aTags == null)
	{
		tagseverywhere_GetTags(sUrl, page);
	} else {
		tagseverywhere_ShowTags(page, aTags);
	}

	return true;
}






function tagseverywhere_PageLoad(e)
{
	var bDisabled = tagseverywhere_getBoolPref(TAGS_PREF_DISABLE, false);
	if(bDisabled)
		return;

	tagseverywhere_doc = e.originalTarget;

	if(tagseverywhere_doc.defaultView.parent.frames &&
			tagseverywhere_doc.defaultView.frames &&
			tagseverywhere_doc.defaultView.frames.length != tagseverywhere_doc.defaultView.parent.frames.length)
	{
		return false;
	} else if(tagseverywhere_doc.defaultView.parent.frames &&
			tagseverywhere_doc.defaultView.frames &&
			tagseverywhere_doc.defaultView.frames.length == tagseverywhere_doc.defaultView.parent.frames.length &&
			tagseverywhere_doc.body &&
			tagseverywhere_doc.body.tagName==='FRAMESET')
	{
		return false;
	}


	var sUrl = "" + tagseverywhere_doc.location.href;
	if (sUrl.substring(0,6).toLowerCase() == "about:")
		return;
	// check exclude domains
	var domain = tagseverywhere_getHost(sUrl);
	var doms = tagseverywhere_getStrPref(TAGS_PREF_EXCLUDE);
	var exdom=doms.split(/\n/i);
	var i;
	var bSkipPageTags = false;
	var bShowPlain = tagseverywhere_getBoolPref(TAGS_PREF_SHOWPLAIN, false);

	if (! bShowPlain)
		bSkipPageTags = true;
	else
		for(i=0;i<exdom.length;i++){
			if(exdom[i]!==''){
				try{
					exdom[i] = exdom[i].replace(/\s|\t/g,'');
					exdom[i] = exdom[i].replace(/\./g,'\\.');
					exdom[i] = exdom[i].replace(/\*/g,'.*');
					var re = new RegExp('^'+exdom[i]+'$','i');
					if(domain.match(re)) bSkipPageTags = true;
				}catch(e){
					alert('Regexp error: '+e);
				}
			}
		}

	// kill old requests
	for (i=0; i<tagseverywhere_reqs.length; i++)
	{
		if (tagseverywhere_reqs[i] != null)
		{
			tagseverywhere_reqs[i].onreadystatechange = function() {};
			tagseverywhere_reqs[i] = null;
		}
	}
	tagseverywhere_reqs = new Array();



	if (! bSkipPageTags)
	{
		// should we use cache?
		var bCache = tagseverywhere_getBoolPref(TAGS_PREF_CACHE, true);
		if (! bCache)
		{
			tagseverywhere_ShowPageTags(sUrl, null);
		} else {
			// we need to use cache
			tagseverywhere_md5 = hex_md5(sUrl);
			if (tagseverywhere_cache[tagseverywhere_md5])
			{
				var aTags = tagseverywhere_cache[tagseverywhere_md5];
				tagseverywhere_ShowPageTags(null, aTags);
			} else {
				tagseverywhere_ShowPageTags(sUrl, null);
			}
		}
	}

	tagseverywhere_parsePage();
}


function tagseverywhere_registerListener() 
{ 
	tagseverywhere_cache = new Array();

	if(! tagseverywhere_isSetPref(TAGS_PREF_EXCLUDE))
		tagseverywhere_setStrPref(TAGS_PREF_EXCLUDE, '*.google.*\n*.search.yahoo.*\nsearch.yahoo.*\n*.search.*msn.*\nsearch.*msn.*\nsearch.live.com\nwww.live.com\nlive.com\n*digg.com\n*reddit.com\n*del.icio.us\n*googlesyndication.com');

	if(! tagseverywhere_isSetPref(TAGS_PREF_CLOUDS))
		tagseverywhere_setBoolPref(TAGS_PREF_CLOUDS, true);
	if(! tagseverywhere_isSetPref(TAGS_PREF_CACHE))
		tagseverywhere_setBoolPref(TAGS_PREF_CACHE, true);

	if(! tagseverywhere_isSetPref(TAGS_PREF_SHOWPLAIN))
		tagseverywhere_setBoolPref(TAGS_PREF_SHOWPLAIN, true);
	if(! tagseverywhere_isSetPref(TAGS_PREF_SHOWSE))
		tagseverywhere_setBoolPref(TAGS_PREF_SHOWSE, true);
	if(! tagseverywhere_isSetPref(TAGS_PREF_SHOWWEB2))
		tagseverywhere_setBoolPref(TAGS_PREF_SHOWWEB2, true);

//	window.getBrowser().addProgressListener(tagseverywhere_Listener, TAGS_NOTIFY_STATE_DOCUMENT);

	var appcontent = document.getElementById("appcontent");
	if(appcontent) appcontent.addEventListener("load", tagseverywhere_PageLoad, true);


	var bDisable = tagseverywhere_getBoolPref(TAGS_PREF_DISABLE, false);

	var iclass = "";
	if(bDisable)
		iclass='tagseverywhere-disabled';
	else
		iclass='tagseverywhere-enabled';
	document.getElementById('tagseverywhere-status').className=iclass;

	tagseverywhere_UpdateMenu();
} 

function tagseverywhere_unregisterListener() 
{ 
	window.getBrowser().removeProgressListener(tagseverywhere_Listener); 
} 

function tagseverywhere_UpdateMenu()
{
	document.getElementById('tagseverywhere-clouds-ch').setAttribute('checked', 
		(tagseverywhere_getBoolPref(TAGS_PREF_CLOUDS, false)) ? 'true' : 'false'
	);
	document.getElementById('tagseverywhere-newwindow-ch').setAttribute('checked', 
		(tagseverywhere_getBoolPref(TAGS_PREF_NEWWINDOW, false)) ? 'true' : 'false'
	);
	document.getElementById('tagseverywhere-cache-ch').setAttribute('checked', 
		(tagseverywhere_getBoolPref(TAGS_PREF_CACHE, false)) ? 'true' : 'false'
	);
	document.getElementById('tagseverywhere-showplain-ch').setAttribute('checked', 
		(tagseverywhere_getBoolPref(TAGS_PREF_SHOWPLAIN, false)) ? 'true' : 'false'
	);
	document.getElementById('tagseverywhere-showse-ch').setAttribute('checked', 
		(tagseverywhere_getBoolPref(TAGS_PREF_SHOWSE, false)) ? 'true' : 'false'
	);
	document.getElementById('tagseverywhere-showweb2-ch').setAttribute('checked', 
		(tagseverywhere_getBoolPref(TAGS_PREF_SHOWWEB2, false)) ? 'true' : 'false'
	);
}

function tagseverywhereToggle(ev)
{
	if(ev.button != 0 ) return;
	var disall = 'false';
	var dis=false;
	var iclass = document.getElementById('tagseverywhere-status').className;
	if(iclass==='tagseverywhere-enabled')
	{
		iclass='tagseverywhere-disabled';
		disall='true';
		dis=true;
	} else {
		iclass='tagseverywhere-enabled';
		disall='false';
		dis=false;
	}

	tagseverywhere_setBoolPref(TAGS_PREF_DISABLE, dis);
	document.getElementById('tagseverywhere-status').className=iclass;

}


function tagseverywhere_xdoPrefs(param, pref)
{
	try
	{
		var att = document.getElementById(param+'-ch').getAttribute('checked');
		if(att != 'true'){
			att = false;
			document.getElementById(param+'-ch').setAttribute('checked', 'false');
		}else{
			att=true;
		}
		tagseverywhere_setBoolPref(''+pref, att)
	}catch(e){
		window.alert('Debug. Settings. ['+param+']: '+e);
	}
}


function tagseverywhere_clearCache()
{
	tagseverywhere_cache = new Array();
}














function tagseverywhere_goTab(tab, url, se)
{
		if(!url) return;

		var span = tab.rows[0].cells.length;
		var row = tagseverywhere_doc.createElement('TR');
		var cell= tagseverywhere_doc.createElement('TD');
		cell.setAttribute('colspan', span);
		cell.setAttribute('style', 'padding:0pt;margin:0pt');
		cell.innerHTML='<table style="border:0pt; margin:0pt;"><tr valign="middle"><td style="padding:0pt"></td></tr></table>\n';
		row.appendChild(cell);
		tab.childNodes[0].appendChild(row);

		var page = tagseverywhere_doc.createElement('DIV');
		tab.childNodes[0].rows[1].cells[0].childNodes[0].childNodes[0].rows[0].insertBefore(page, null);
		page.setAttribute('align','center');
		page.setAttribute('style','font: 12 arial; color: #000000; background:#F0F0F0;width:100%;padding:0pt;margin:0pt;z-index:1000;position:relative');
		page.innerHTML='&nbsp; <b>Common tags</b>: wait...';

		var bCache = tagseverywhere_getBoolPref(TAGS_PREF_CACHE, true);
		if (! bCache)
		{
			tagseverywhere_GetTags(url, page);
		} else {
			// we need to use cache
			tagseverywhere_md5 = hex_md5(url);
			if (tagseverywhere_cache[tagseverywhere_md5])
			{
				var aTags = tagseverywhere_cache[tagseverywhere_md5];
				tagseverywhere_ShowTags(page, aTags);
			} else {
				tagseverywhere_GetTags(url, page);
			}
		}

}

function tagseverywhere_parsePage()
{
	var rematch;
	if (tagseverywhere_getBoolPref(TAGS_PREF_SHOWSE, false))
	{
		rematch = new RegExp('http://.*google\..*/search.*q=.*','i');
		var is_google = tagseverywhere_doc.location.href.match(rematch);
		if(is_google)
		{
			tagseverywhere_useGoogle();
			return;
		}

		rematch = new RegExp('http://.*search\.yahoo\..*/search.*','i');
		if(tagseverywhere_doc.location.href.match(rematch))
		{
			tagseverywhere_useYahoo();
			return;
		}

		rematch = new RegExp('http://.*search\.msn\..*/results.aspx.*','i');
		if(tagseverywhere_doc.location.href.match(rematch))
		{
			tagseverywhere_useMsn();
			return;
		}

		rematch = new RegExp('http://.*search\.live\..*/results.aspx.*','i');
		if(tagseverywhere_doc.location.href.match(rematch))
		{
			tagseverywhere_useMsn();
			return;
		}

	}

	if (tagseverywhere_getBoolPref(TAGS_PREF_SHOWWEB2, false))
	{

		rematch = new RegExp('http://(.*\.)?digg\.com/','i');
		var is_digg = tagseverywhere_doc.location.href.match(rematch);
		if(is_digg)
		{
			tagseverywhere_useDigg();
			return;
		}


		rematch = new RegExp('http://(.*\.)?reddit\.com/','i');
		var is_reddit = tagseverywhere_doc.location.href.match(rematch);
		if(is_reddit)
		{
			tagseverywhere_useReddit();
			return;
		}

	}

}

function tagseverywhere_useGoogle()
{
		//  
		var pin=null;
		var ps = tagseverywhere_doc.getElementsByTagName('P');
		for(i=0;i<ps.length;i++){
			if(ps[i].className==='g' &&
				ps[i].innerHTML.search(/class="?l"?/i) > 0){
				var tab=null;
				var url=null;
				var z=0;
				for(z=0; z < ps[i].childNodes.length; z++){
					if(ps[i].childNodes[z].tagName==='A' && !url) url=ps[i].childNodes[z].href;
					if(ps[i].childNodes[z].tagName==='TABLE' && !tab) tab=ps[i].childNodes[z];
				}

				if(tab.tagName!=='TABLE') return;
				var re = new RegExp('<a.+href="(.+?cache:.+?)">');
				var match = re.exec(ps[i].innerHTML);
				try{
					if(pin==null){
						var tb=tagseverywhere_doc.createElement('TABLE');
						tb.setAttribute('width','100%');
						tb.id='tagseverywhere-googlebar';
						var tbd=tagseverywhere_doc.createElement('TBODY');
						var tr=tagseverywhere_doc.createElement('TR');
						var td=tagseverywhere_doc.createElement('TD');
						tr.appendChild(td);
						tbd.appendChild(tr);
						tb.appendChild(tbd);
						ps[i].parentNode.insertBefore(tb,ps[i]);
						pin=1;
					}
					tagseverywhere_goTab(tab, url,'google');
				}catch(e){
					window.alert('ERROR: '+e);
				}
			}
		}
		ps = tagseverywhere_doc.getElementsByTagName('DIV');
		for(i=0;i<ps.length;i++){
			if(ps[i].className==='g' &&
				ps[i].innerHTML.search(/class="?l"?/i) > 0){
				var tab=null;
				var url=null;
				var h2=null;
				var z=0;
				for(z=0; z < ps[i].childNodes.length; z++){
					if(ps[i].childNodes[z].tagName==='H2' && ps[i].childNodes[z].className==='r' && h2 == null) h2 = ps[i].childNodes[z];
					if(ps[i].childNodes[z].tagName==='A' && url == null) url=ps[i].childNodes[z].href;
					if(ps[i].childNodes[z].tagName==='TABLE' && !tab) tab=ps[i].childNodes[z];
				}


				if (url == null && h2 != null)
					for(z=0; z < h2.childNodes.length; z++)
						if(h2.childNodes[z].tagName==='A' && url == null) url=h2.childNodes[z].href;

				if(tab.tagName!=='TABLE') return;
				var re = new RegExp('<a.+href="(.+?cache:.+?)">');
				var match = re.exec(ps[i].innerHTML);
				try{
					if(pin==null){
						var tb=tagseverywhere_doc.createElement('TABLE');
						tb.setAttribute('width','100%');
						tb.id='tagseverywhere-googlebar';
						var tbd=tagseverywhere_doc.createElement('TBODY');
						var tr=tagseverywhere_doc.createElement('TR');
						var td=tagseverywhere_doc.createElement('TD');
						tr.appendChild(td);
						tbd.appendChild(tr);
						tb.appendChild(tbd);
						ps[i].parentNode.insertBefore(tb,ps[i]);
						pin=1;
					}
					tagseverywhere_goTab(tab, url,'google');
				}catch(e){
					window.alert('ERROR: '+e);
				}
			}
		}
}



function tagseverywhere_useYahoo()
{
		//  
		var pin=null;
		var i=0;
		var ps = tagseverywhere_doc.getElementsByTagName('LI');
		for(i=0;i<ps.length;i++){
			try{
			if(ps[i].firstChild &&
				ps[i].firstChild.tagName ==='DIV' &&
				ps[i].firstChild.firstChild &&
				ps[i].firstChild.firstChild.tagName ==='A'){
					var tab;
					var url=ps[i].firstChild.firstChild.href;
					var match = url.match(/\*{2}(.*)/i);
					if(match){
						url = unescape(match[1]);
					}
					
					var tb=tagseverywhere_doc.createElement('TABLE');
					var tbd=tagseverywhere_doc.createElement('TBODY');
					var tr=tagseverywhere_doc.createElement('TR');
					var td=tagseverywhere_doc.createElement('TD');
					tr.appendChild(td);
					tbd.appendChild(tr);
					tb.appendChild(tbd);
					ps[i].appendChild(tb);
					tab = ps[i].lastChild;

					if(tab.tagName!=='TABLE') return;


					try{
						if(pin==null){
							pin=1;
							var tb=tagseverywhere_doc.createElement('TABLE');
							tb.setAttribute('width','100%');
							tb.id='tagseverywhere-yahoobar';
							var tbd=tagseverywhere_doc.createElement('TBODY');
							var tr=tagseverywhere_doc.createElement('TR');
							var td=tagseverywhere_doc.createElement('TD');
							tr.appendChild(td);
							tbd.appendChild(tr);
							tb.appendChild(tbd);
							ps[i].parentNode.parentNode.insertBefore(tb,ps[i].parentNode);
						}
						
						tagseverywhere_goTab(tab,url, 'yahoo');
					}catch(e){
						//window.alert('ERROR: '+e);
					}
			}
			}catch(e){
				//window.alert('XCXERROR: '+e);
			}
		}
}

function tagseverywhere_useMsn()
{
		//  
		var pin = null;
		var px = tagseverywhere_doc.getElementById('results');
		if (!px) return;
        
		var i = 0;
		var ps = px.childNodes[i];
        
		while(px.childNodes[i] && ps.tagName !== 'UL'){
            i++;
            ps = px.childNodes[i];
        }
        
        if (ps.tagName !== 'UL') return;
        
		ps = ps.childNodes;
		for(i=0;i<ps.length;i++){
			if((ps[i].firstChild &&
				ps[i].firstChild.firstChild &&
				ps[i].firstChild.firstChild.tagName === 'A' &&
				ps[i].childNodes[1] &&
				ps[i].childNodes[1].tagName === 'P' &&
				ps[i].childNodes[2] &&
				ps[i].childNodes[2].tagName === 'UL') ||
				(ps[i].firstChild &&
				ps[i].firstChild.tagName==='H3' &&
				ps[i].firstChild.firstChild && 
				ps[i].firstChild.firstChild.tagName==='A')){

				var tab;
				
                var url = ps[i].firstChild.firstChild.href;
                if (url.indexOf('g.msn.com') != -1) {
                    url = url.replace(/(&amp;)/g, '&')
                    var foo = url.match(/\?(https*:\/\/.+)[&]{2}/i);
                    url = (foo) ? foo[1].replace(/(&amp;)/g, '&') : '';
                }
				
                var tb=tagseverywhere_doc.createElement('TABLE');
				var tbd=tagseverywhere_doc.createElement('TBODY');
				var tr=tagseverywhere_doc.createElement('TR');
				var td=tagseverywhere_doc.createElement('TD');
				tr.appendChild(td);
				tbd.appendChild(tr);
				tb.appendChild(tbd);
				ps[i].appendChild(tb);
				tab = ps[i].lastChild;

				if(tab.tagName!=='TABLE') return;

				try{
					if(pin==null){
						pin=1;
						var tb=tagseverywhere_doc.createElement('TABLE');
						tb.setAttribute('width','100%');
						tb.id='tagseverywhere-msnbar';
						var tbd=tagseverywhere_doc.createElement('TBODY');
						var tr=tagseverywhere_doc.createElement('TR');
						var td=tagseverywhere_doc.createElement('TD');
						tr.appendChild(td);
						tbd.appendChild(tr);
						tb.appendChild(tbd);
						ps[i].parentNode.parentNode.insertBefore(tb,ps[i].parentNode);
					}
					tagseverywhere_goTab(tab,url,'msn');
				}catch(e){
					//window.alert('ERROR: '+e);
				}
			}
		}
}




function tagseverywhere_useDigg()
{

		//  digg.com
		var pin = null;

		var ii = 0;

		var pParent = tagseverywhere_doc.getElementById('enclosure' + ii);
		while (pParent)
		{
			var url = "";
			var ps = pParent.childNodes;
			var i;
			for(i=0;i<ps.length;i++)
			{
				if(ps[i].tagName==='DIV')
				{

					var ps2 = ps[i].childNodes;
					var i2;
					for(i2=0;i2<ps2.length;i2++)
					{
						if(ps2[i2].tagName==='H3')
						{
							if (ps2[i2].firstChild.tagName==='A')
							{
								url = ps2[i2].firstChild.href;
								break;
							}
						}
					}
					if (url != "")
						break;
				}
			}


			if (url != "")
			{
	
//alert(url);

				//var pParent = tagseverywhere_doc.getElementById('enclosure' + i);
				pParent = pParent.childNodes[1];


				var tab;
				var pp=tagseverywhere_doc.createElement('DIV');
					pp.setAttribute('width','100%');
//					pp.className = 'news-digg';
//					pp.style.float = 'none';
				var tb=tagseverywhere_doc.createElement('TABLE');
					tb.setAttribute('width','100%');
				var tbd=tagseverywhere_doc.createElement('TBODY');
				var tr=tagseverywhere_doc.createElement('TR');
				var td=tagseverywhere_doc.createElement('TD');
				tr.appendChild(td);
				tbd.appendChild(tr);
				tb.appendChild(tbd);
				pp.appendChild(tb);

				var br=tagseverywhere_doc.createElement('BR');
				br.setAttribute('clear','all');

				pParent.appendChild(br);
				pParent.appendChild(pp);

				//pParent.insertBefore(pp, pParent.childNodes[2]);
				//pParent.insertBefore(pp, br);
				

				tab = tb;
				//tab = pParent.lastChild;
				//if(tab.tagName!=='P') return;

				try {

/*
					if(pin==null){
						pin=1;
						var tb=tagseverywhere_doc.createElement('TABLE');
						tb.setAttribute('width','100%');
						tb.id='tagseverywhere-diggbar';
						var tbd=tagseverywhere_doc.createElement('TBODY');
						var tr=tagseverywhere_doc.createElement('TR');
						var td=tagseverywhere_doc.createElement('TD');
						tr.appendChild(td);
						tbd.appendChild(tr);
						tb.appendChild(tbd);
						pParent.parentNode.insertBefore(tb,pParent);
					}
*/

					tagseverywhere_goTab(tab,url,'digg');
				} catch(e) {
					//window.alert('ERROR: '+e);
				}

			}

			ii ++;
			pParent = tagseverywhere_doc.getElementById('enclosure' + ii);
				
		}



}




function tagseverywhere_useReddit()
{
		//  reddit.com
		var pin = null;

		var i;
		var siteTable = tagseverywhere_doc.getElementById('siteTable');
		if (! siteTable)
			return;

		var rows = siteTable.rows;

		var n = rows.length / 4;

		for (i = 0; i < n; i++)
		{
			var tr = rows[i*4 + 1];
			var a = tr.cells[2].childNodes[1];
			if (a.tagName==='A')
			{
				url = a.href;
				tr = rows[i*4 + 2];
				var cell = tr.cells[0];

				var tb_ =tagseverywhere_doc.createElement('TABLE');
				var tbd_ =tagseverywhere_doc.createElement('TBODY');
				var tr_ =tagseverywhere_doc.createElement('TR');
				var td_ =tagseverywhere_doc.createElement('TD');
				tr_.appendChild(td_);
				tbd_.appendChild(tr_);
				tb_.appendChild(tbd_);
				cell.appendChild(tb_);

				tab = tb_;
				try{
					tagseverywhere_goTab(tab,url,'digg');
				}catch(e){
					//window.alert('ERROR: '+e);
				}

			}


		}


}


